#ifndef UTILITY_H
#define UTILITY_H

// Return direction of a double
#define dir(r) ((r) < 0 ? -1 : 1.0)


/* Point type */
typedef struct point2d
{
    
    point2d(void) {};
    
    point2d(double nx, double ny) {x=nx; y=ny;};
    
    double x;
    double y;
};

point2d get_point( double x, double y);

point2d operator* ( double s, point2d p);
point2d operator* ( point2d p, double s);
point2d operator/ (point2d p, double s);
point2d operator- ( point2d p1, point2d p2);
point2d operator+ ( point2d p1, point2d p2);

point2d operator+= ( point2d &p1, point2d p2);
point2d operator-= ( point2d &p1, point2d p2);


double dot ( point2d p1, point2d p2);

point2d get_ortho_unit(point2d p);
void normalize(point2d p);
double length( point2d p );

double cross(point2d p1, point2d p2);

double f_rand(double s, double e);
double get_time( void );

void write_console(char * str);

void debug_start( void );
void debug(char *t);
void debug(char *t, double n);
void debug(char *t, int n);

COLORREF rand_color( void );

#endif
